####################################################################################################
###   Quel est le nobre d'opérations élémentaires pour inverser tous les éléments d'une liste ?  ###
####################################################################################################


def rotation_liste(pile, index):
    """
    Fonction qui permet d'inverser les élements d'une liste
    """
    #On initialise de compteur d'opérations élémentaires
    compteur=0
    nombre_inversions = index // 2    #  affectation unique qui n'est effectuée qu'une unique fois. Négligeable
    for i in range(nombre_inversions):
        j = index - 1 - i
        aux = pile[i]
        pile[i] = pile[j]
        pile[j] = aux
        compteur = compteur + 4

    return (pile, compteur)


if __name__ == '__main__':
    from random import sample
    pile = sample(range(1, 100000), 1000)
    #pile = [1, 4, 5, 2, 12, 8, 6, 7, 9, 3] #les nombres correspondent à la taille des crêpes
    print(pile)
    pile_renverse, nb_operations = rotation_liste(pile, len(pile))
    print( "\nListe renversées:", pile_renverse)
    print(nb_operations)