def tri_crepe(pile):
    for i in (range(len(pile)-1, -1, -1)):#lecture de la pile en sens inverse
        pile = rotation_liste(pile, position_grande_crepe(pile, i))
        #print("\nMonter la grande crêpe", pile)
        pile = rotation_liste(pile, i)
        #print("Retourner la pile de crêpes", pile)
    return pile

def inverser_signe(pile,index_ini,index_fin):
    """
    inverser les signes des elements de la liste pile à partir de l'index_mini jusqu'à l'index_max
    """
    for i in range(index_ini,index_fin+1):
        pile[i]=-pile[i]
    return pile
    

def indice_grande_crepe(pile, index): # Mystere A
    """
    Fonction qui reçoit en argument une liste d'entiers non triées et un entier index qui
    corespond à l'indice du dernier élément de la liste non triée.
    La fonction retourne l'indice de la plus grande crêpe de la liste.
    """
    indice_gc = 0
    for i in range(index+1):
        if abs(pile[i])> abs(pile[indice_gc]):#on compare les valeurs absolus des nombres
            indice_gc = i
    return indice_gc


def rotation_liste(pile, index): # Mystère B
    """
    Fonction qui glisse la spatule sous la crêpe au bon index et retourne la pile du haut sélectionné
    pour mettre la grande crêpe en haut
    """
    pile_modifie = pile[:(index + 1)] #selection de la partie de la pile selectionnée
    pile_modifie.reverse() #inversion des valeur du pileleau selectionné
    pile_modifie=inverser_signe(pile_modifie,0,index) #on inverse les signe de tous les nombres de la pile retournée
    pile_modifie += pile[(index + 1):] #recomposition de la pilele
    return pile_modifie


def ordonner(pile):
    for i in (range(len(pile)-1, -1, -1)):#i nombre de crêpes de la pile restant à trier
        # calcul de l'indice max de la plus grand crêpe
        indice_max = indice_grande_crepe(pile, i)
        # on retourne la pile de crêpes à partir de la plus grande
        pile = rotation_liste(pile, indice_max)
        print("\nMonter la grande crêpe", pile)
        # on verifie et on met la grande crêpe face brulée vers le haut
        if (pile[0]>0):
            pile=inverser_signe(pile,0,0) 
          
        # on retourne uniquement la pile de crêpes non triées
        pile = rotation_liste(pile, i)
        
        print("Retourner la pile de crêpes", pile)
    return pile


if __name__ == '__main__':
    pile = [1,5,12,4,-6,7,14,10] #les nombres correspondent à la taille des crêpes
    if (pile): #verification que la liste contient au moins un élément
        print("\ncrêpes non trièes:")
        print (pile)
        print( "\nLes itérations:")  
        pile_triee=ordonner(pile)
        print( "\nCrêpes triées:", pile_triee)
    else:
        print("\nOh, zut, le chat a mangé toutes les crêpes!")
    